Leetcode: Maximum Size Subarray Sum Equals k

 


Given an array nums and a target value k, find the maximum length of a subarray that sums to k. If there isn't one, return 0 instead.

Example 1:

Given nums = [1, -1, 5, -2, 3]k = 3,
return 4. (because the subarray [1, -1, 5, -2] sums to 3 and is the longest)

Example 2:

Given nums = [-2, -1, 2, 1]k = 1,
return 2. (because the subarray [-1, 2] sums to 1 and is the longest)

Follow Up:
Can you do it in O(n) time?



public class Solution {
    public int maxSubArrayLen(int[] nums, int k) {
        
    }
}


容易想到的思路如下:

以每个字母作为首字母循环 nums.length 遍

每次逐位向后加sum

如果在hashmap存在

找到结果,返回


【优化】

即使当前的sum不在hashmap中,但是为了不浪费已经加过的数,考虑其中的一部分可能满足条件:

把subarray分成两部分,后半部分如果是k也算不枉一路相加,而前半部分肯定在hashmap中了

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值